import { ClientPlatform, ClientsInRoomMap, EventDecoder } from 'matrix-protection-suite';
import { MatrixSendClient } from '../MatrixEmitter';
import { StringUserID } from '@the-draupnir-project/matrix-basic-types';
/**
 * Creates client capabilities that reference a ClientsInRoomMap so that
 * the joined rooms can be preempted consistently.
 */
export declare class ClientCapabilityFactory {
    private readonly clientsInRoomMap;
    private readonly eventDecoder;
    constructor(clientsInRoomMap: ClientsInRoomMap, eventDecoder: EventDecoder);
    makeClientPlatform(clientUserID: StringUserID, client: MatrixSendClient): ClientPlatform;
}
//# sourceMappingURL=ClientCapabilityFactory.d.ts.map