import { RoomBanner } from './RoomBanner';
import { RoomCreator } from './RoomCreator';
import { RoomEventGetter } from './RoomEventGetter';
import { RoomEventRedacter } from './RoomEventRedacter';
import { RoomEventRelationsGetter } from './RoomEventRelationsGetter';
import { RoomInviter } from './RoomInviter';
import { RoomJoiner } from './RoomJoiner';
import { RoomKicker } from './RoomKicker';
import { RoomMessageSender } from './RoomMessageSender';
import { RoomReactionSender } from './RoomReactionSender';
import { RoomResolver } from './RoomResolver';
import { RoomStateEventSender } from './RoomStateEventSender';
import { RoomUnbanner } from './RoomUnbanner';
/**
 * A `ClientPlatform` has all the capabilities associated with a client.
 * This might end up forming a tree in the future, where you go down to
 * narrow to attenuate furhter.
 * Very little should accept the entire client platform as an argument,
 * only the individual capabilities. An example situations where this would
 * be acceptable is a bot plugin platform itself that needs to setup lots
 * of dependencies.
 */
export interface ClientPlatform {
    toRoomBanner(): RoomBanner;
    toRoomCreator(): RoomCreator;
    toRoomEventGetter(): RoomEventGetter;
    toRoomEventRedacter(): RoomEventRedacter;
    toRoomEventRelationsGetter(): RoomEventRelationsGetter;
    toRoomInviter(): RoomInviter;
    toRoomJoiner(): RoomJoiner;
    toRoomKicker(): RoomKicker;
    toRoomResolver(): RoomResolver;
    toRoomReactionSender(): RoomReactionSender;
    toRoomStateEventSender(): RoomStateEventSender;
    toRoomUnbanner(): RoomUnbanner;
    toRoomMessageSender(): RoomMessageSender;
}
//# sourceMappingURL=ClientPlatform.d.ts.map