"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PermalinkSchema = void 0;
// Copyright (C) 2023 Gnuxie <Gnuxie@protonmail.com>
//
// SPDX-License-Identifier: AFL-3.0
const typescript_result_1 = require("@gnuxie/typescript-result");
const typebox_1 = require("@sinclair/typebox");
const matrix_basic_types_1 = require("@the-draupnir-project/matrix-basic-types");
exports.PermalinkSchema = typebox_1.Type.Transform(typebox_1.Type.String())
    .Decode((value) => {
    const permalinkResult = matrix_basic_types_1.MatrixRoomReference.fromPermalink(value);
    if ((0, typescript_result_1.isError)(permalinkResult)) {
        throw new TypeError(permalinkResult.error.message);
    }
    else {
        return permalinkResult.ok;
    }
})
    .Encode((value) => value.toPermalink());
//# sourceMappingURL=PermalinkSchema.js.map