import EventEmitter from 'events';
import { RoomMembershipRevisionIssuer } from './MembershipRevisionIssuer';
import { RoomMembershipRevision } from './MembershipRevision';
import { RoomMembershipManager } from './RoomMembershipManager';
import { MembershipEvent } from '../MatrixTypes/MembershipEvent';
import { Redaction } from '../MatrixTypes/Redaction';
import { MatrixRoomID } from '@the-draupnir-project/matrix-basic-types';
/**
 * Users of this class are strongly recommended to consider the
 * RoomState based alternative `RoomStateMembershipRevisionIssuer`.
 * This class will likely be removed shortly.
 */
export declare class StandardRoomMembershipRevisionIssuer extends EventEmitter implements RoomMembershipRevisionIssuer {
    readonly room: MatrixRoomID;
    currentRevision: RoomMembershipRevision;
    private readonly roomMembershipManager;
    private currentBatch;
    private batchCompleteCallback;
    constructor(room: MatrixRoomID, currentRevision: RoomMembershipRevision, roomMembershipManager: RoomMembershipManager);
    private addToBatch;
    updateForMembershipEvent(event: MembershipEvent): void;
    updateForRedactionEvent(event: Redaction): void;
    private createBatchedRevision;
    unregisterListeners(): void;
}
//# sourceMappingURL=StandardRoomMembershipRevisionIssuer.d.ts.map