"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MjolnirShortcodeEvent = exports.MjolnirShortcodeEventContent = exports.MJOLNIR_SHORTCODE_EVENT_TYPE = exports.POLICY_ROOM_TYPE_VARIANTS = exports.POLICY_ROOM_TYPE = void 0;
// Copyright 2022 - 2023 Gnuxie <Gnuxie@protonmail.com>
// Copyright 2019 - 2021 The Matrix.org Foundation C.I.C.
//
// SPDX-License-Identifier: AFL-3.0 AND Apache-2.0
//
// SPDX-FileAttributionText: <text>
// This modified file incorporates work from mjolnir
// https://github.com/matrix-org/mjolnir
// </text>
const typebox_1 = require("@sinclair/typebox");
const Events_1 = require("../MatrixTypes/Events");
/** MSC3784 support. Please note that policy lists predate room types. So there will be lists in the wild without this type. */
exports.POLICY_ROOM_TYPE = 'support.feline.policy.lists.msc.v1';
exports.POLICY_ROOM_TYPE_VARIANTS = [exports.POLICY_ROOM_TYPE];
exports.MJOLNIR_SHORTCODE_EVENT_TYPE = 'org.matrix.mjolnir.shortcode';
exports.MjolnirShortcodeEventContent = typebox_1.Type.Object({
    shortcode: typebox_1.Type.Optional(typebox_1.Type.String()),
});
exports.MjolnirShortcodeEvent = (0, Events_1.StateEvent)(exports.MjolnirShortcodeEventContent);
//# sourceMappingURL=PolicyListRevision.js.map