"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FakeProtectionsConfig = void 0;
// SPDX-FileCopyrightText: 2024 Gnuxie <Gnuxie@protonmail.com>
//
// SPDX-License-Identifier: AFL-3.0
const PersistentConfigData_1 = require("../../Config/PersistentConfigData");
const FakePersistentMatrixData_1 = require("../../Interface/FakePersistentMatrixData");
const LoggableConfig_1 = require("../../Interface/LoggableConfig");
const MjolnirEnabledProtectionsDescription_1 = require("../ProtectionsConfig/MjolnirEnabledProtectionsDescription");
const StandardProtectionsConfig_1 = require("../ProtectionsConfig/StandardProtectionsConfig");
class FakeProtectionsConfig extends StandardProtectionsConfig_1.MjolnirProtectionsConfig {
    constructor() {
        super(new PersistentConfigData_1.StandardPersistentConfigData(MjolnirEnabledProtectionsDescription_1.MjolnirEnabledProtectionsDescription, new FakePersistentMatrixData_1.FakePersistentConfigBackend({})), new LoggableConfig_1.StandardLoggableConfigTracker(), {
            knownEnabledProtections: [],
            unknownEnabledProtections: [],
        });
    }
}
exports.FakeProtectionsConfig = FakeProtectionsConfig;
//# sourceMappingURL=FakeProtectionsConfig.js.map