"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FakeProtectionsManager = void 0;
// SPDX-FileCopyrightText: 2024 Gnuxie <Gnuxie@protonmail.com>
//
// SPDX-License-Identifier: AFL-3.0
const typescript_result_1 = require("@gnuxie/typescript-result");
const FakeProtectionsConfig_1 = require("../ProtectionsConfig/FakeProtectionsConfig");
const StandardProtectionCapabilityProviderSetConfig_1 = require("../ProtectionsConfig/ProtectionCapabilityProviderSetConfig/StandardProtectionCapabilityProviderSetConfig");
const MjolnirProtectionSettingsConfig_1 = require("../ProtectionsConfig/ProtectionSettingsConfig/MjolnirProtectionSettingsConfig");
const StandardProtectionsManager_1 = require("./StandardProtectionsManager");
const FakePersistentMatrixData_1 = require("../../Interface/FakePersistentMatrixData");
class FakeProtectionsManager extends StandardProtectionsManager_1.StandardProtectionsManager {
    constructor() {
        super(new FakeProtectionsConfig_1.FakeProtectionsConfig(), new StandardProtectionCapabilityProviderSetConfig_1.StandardProtectionCapabilityProviderSetConfig(function () {
            return (0, typescript_result_1.Ok)(new FakePersistentMatrixData_1.FakePersistentConfigBackend({}));
        }), new MjolnirProtectionSettingsConfig_1.MjolnirProtectionSettingsConfig(function () {
            return (0, typescript_result_1.Ok)(new FakePersistentMatrixData_1.FakePersistentConfigBackend({}));
        }));
    }
}
exports.FakeProtectionsManager = FakeProtectionsManager;
//# sourceMappingURL=FakeProtectionsManager.js.map